#include <windows.h>
#include "nAPI.h"

namespace nAPI {
	pAddNative AddNative;
	pStringMap StringMap;
	pStringGet StringGet;
	pGetUnitInfoStruct GetUnitInfoStruct;
	pGetAbilityInfoStruct GetAbilityInfoStruct;
	pAddRCHandle AddRCHandle;
	pGetRCHandle GetRCHandle;
	pRecycleRCHandle RecycleRCHandle;
	pRegisterHandleDestructor RegisterHandleDestructor;
	pGameDebugMessage GameDebugMessage;
	pCreateTriggerGroup CreateTriggerGroup;
	pDestroyTriggerGroup DestroyTriggerGroup;
	pTriggerGroupAdd TriggerGroupAdd;
	pTriggerGroupRun TriggerGroupRun;
	pGetWc3WindowHandle GetWc3WindowHandle;
	
	MouseInfoStruct *MouseInfo;
	char *LastNativeName;
	
	long RealMap(float in) {
		return (*((long*)&in));
	}
}

using namespace nAPI;

#define InitNAPIFunc(name) name = (p##name)GetProcAddress(m, #name);\
if (!name) return false;

typedef void* (__cdecl *pGetMouseInfoStruct)();
pGetMouseInfoStruct GetMouseInfoStruct;

typedef char* (__cdecl *pGetLastNativeNameAddr)();
pGetLastNativeNameAddr GetLastNativeNameAddr;

bool InitJAPI(HMODULE m) {
	InitNAPIFunc(AddNative);
	InitNAPIFunc(StringMap);
	InitNAPIFunc(StringGet);
	InitNAPIFunc(GetUnitInfoStruct);
	InitNAPIFunc(GetAbilityInfoStruct);
	InitNAPIFunc(AddRCHandle);
	InitNAPIFunc(GetRCHandle);
	InitNAPIFunc(RecycleRCHandle);
	InitNAPIFunc(RegisterHandleDestructor);
	InitNAPIFunc(GameDebugMessage);
	InitNAPIFunc(CreateTriggerGroup);
	InitNAPIFunc(DestroyTriggerGroup);
	InitNAPIFunc(TriggerGroupAdd);
	InitNAPIFunc(TriggerGroupRun);
	InitNAPIFunc(GetMouseInfoStruct);
	InitNAPIFunc(GetLastNativeNameAddr);
	InitNAPIFunc(GetWc3WindowHandle);
	
	MouseInfo = (MouseInfoStruct*)GetMouseInfoStruct();
	LastNativeName = GetLastNativeNameAddr();
	
	return true;
}
