#include <windows.h>
#include "userinput.h"

using namespace nAPI;

extern "C" bool __cdecl LoadNativePack(HMODULE m) {
    if (!InitJAPI(m)) {
        MessageBox(NULL, "Failed to load UserInputAPI!", NULL, MB_ICONERROR);
        return false;
    }
    
	AddNative((void *)TriggerRegisterKeyEvent,      "TriggerRegisterKeyEvent",		"(Htrigger;I)V");
	AddNative((void *)GetTriggerKey,                "GetTriggerKey",	            "()I");
	AddNative((void *)SetKeyBlock,                  "SetKeyBlock",	                "(IB)V");
	
	AddNative((void *)TriggerRegisterMouseEvent,    "TriggerRegisterMouseEvent",	"(Htrigger;I)V");
	AddNative((void *)SetMouseBlock,                "SetMouseBlock",	            "(IB)V");
    AddNative((void *)GetTriggerWheelDelta,         "GetTriggerWheelDelta",	        "()I");
	AddNative((void *)IsMouseOverUI,                "IsMouseOverUI",	            "()B");
    AddNative((void *)GetMouseTargetX,              "GetMouseTerrainX",             "()R");
	AddNative((void *)GetMouseTargetY,              "GetMouseTerrainY",             "()R");
	AddNative((void *)GetMouseTargetZ,              "GetMouseTerrainZ",             "()R");
	AddNative((void *)GetMouseScreenX,              "GetMouseScaleX",               "()R");
	AddNative((void *)GetMouseScreenY,              "GetMouseScaleY",               "()R");
    AddNative((void *)GetMouseX,                    "GetMouseScreenX",              "()I");
	AddNative((void *)GetMouseY,                    "GetMouseScreenY",              "()I");
	AddNative((void *)SetMouseX,                    "SetMouseScreenX",              "(I)V");
    AddNative((void *)SetMouseY,                    "SetMouseScreenY",	            "(I)V");
	AddNative((void *)SetMousePos,                  "SetMouseScreenPos",            "(II)V");
	AddNative((void *)ForceKeyDown,                 "ForceKeyDown",                 "(I)V");
	AddNative((void *)ForceKeyUp,                   "ForceKeyUp",                   "(I)V");
	AddNative((void *)ForceKeyType,                 "ForceKeyType",	                "(I)V");
    
	return true;
}